package lists;

import java.util.Iterator;


public class MyStringLinkedList implements MyStringList {
	private StringNode first;
	private int size;

	@Override
	public void add(String element) {		
		if(first == null) {
			first = new StringNode(null, element, null);
		} else {
			StringNode n = first;
			while(n.next != null) {
				n = n.next;
			}
			
			StringNode nextNode = new StringNode(n, element, null);
			n.next = nextNode;
		}
		
		size++;
	}

	@Override
	public String get(int index) {
		if(index <= size - 1) {
			StringNode n = first;
			
			for(int i = 0; i < index; i++) {
				n = n.next;
			}
			
			return n.item;
		} else {
			return null;
		}
	}

	@Override
	public boolean contains(String element) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void remove(String element) {
		if(element.equals(first.item)) {
			 first = first.next;
		} else {
			StringNode n = first.next;
			
			while(n != null) {
				if(element.equals(n.item)) {
					StringNode prevNode = n.prev;
					StringNode nextNode = n.next;
					
					prevNode.next = nextNode;
					nextNode.prev = prevNode;
					
					break;
				}
			}
		}
		
		size--;
	}

	@Override
	public void remove(int index) {
		if(index <= size - 1) {
			StringNode n = first;
			
			for(int i = 0; i < index; i++) {
				n = n.next;
			}

			StringNode prevNode = n.prev;
			StringNode nextNode = n.next;
			
			prevNode.next = nextNode;
			nextNode.prev = prevNode;
		}
		
		size--;
	}

	@Override
	public int size() {
		return size;
	}
	
	private static class StringNode {
		StringNode prev;
		StringNode next;
		
		String item;
		
		StringNode(StringNode prev, String item, StringNode next) {
			this.prev = prev;
			this.item = item;
			this.next = next;
		}
	}

	@Override
	public Iterator<String> iterator() {
		// TODO Auto-generated method stub
		return new MyIterator(first);
	}
	
	class MyIterator implements Iterator<String> {
		StringNode next;
		
		MyIterator(StringNode node) {
			next = node;
		}
		
		@Override
		public boolean hasNext() {
			return next != null;
		}

		@Override
		public String next() {
			StringNode tmp = next;
			
			next = next.next;
			
			return tmp.item;
			
		}

		@Override
		public void remove() {
			// TODO Auto-generated method stub
			
		}
		
	}
}
